import Combine

public extension Bus {
  final class Processor<Src, Dst> {
    var subscriptions = [AnyCancellable]()

    public init(
      _ handler: @escaping ((Src) -> Dst?),
      _ keyIn: String,
      _ keyOut: String
    ) {
      Bus.processSync([keyIn], keyOut, handler, &subscriptions)
    }

    public init(
      _ handler: @escaping ((Src) -> Dst?),
      _ keysIn: Set<String>,
      _ keyOut: String
    ) {
      Bus.processSync(keysIn, keyOut, handler, &subscriptions)
    }
  }
}
